// ignore_for_file: use_build_context_synchronously
import 'dart:convert';
import 'package:provider/provider.dart';
import '../Basicp1_viewModel/Basicp1_view_model_screen.dart';
import '../../../../utils/image_constant.dart';
import '../../../../utils/size_utils.dart';
import '../../../../theme/app_style.dart';
import '../../../../widgets/app_bar/appbar_image.dart';
import '../../../../widgets/app_bar/appbar_title.dart';
import '../../../../widgets/app_bar/custom_app_bar.dart';
import 'package:barcode_widget/barcode_widget.dart';
import 'package:fluttertoast/fluttertoast.dart';
import '../../../../widgets/custom_button.dart';
import '../../../../widgets/custom_text_form_field.dart';
import 'package:flutter/material.dart';
import 'package:autocomplete_textfield/autocomplete_textfield.dart';
import 'package:qr_flutter/qr_flutter.dart';
import 'package:intl/intl.dart';

import 'dart:math';
import '../../../../Reuseable/reusable_text_field.dart';
import '../../../../Reuseable/reusable_date_picker_field.dart';
import '../../../../Reuseable/reusable_date_time_picker_field.dart';
import '../../../../Reuseable/reusable_dropdown_field.dart';
import 'package:flutter/services.dart';
class basicp1UpdateEntityScreen extends StatefulWidget {
    final Map<String, dynamic> entity;


  basicp1UpdateEntityScreen({required this.entity});

  @override
  _basicp1UpdateEntityScreenState createState() => _basicp1UpdateEntityScreenState();
}

class _basicp1UpdateEntityScreenState extends State<basicp1UpdateEntityScreen> {
  final _formKey = GlobalKey<FormState>();


















  bool _passwordVisiblepassword_field = false;
  bool _isPasswordValidpassword_field = true;
  bool _doPasswordsMatchpassword_field = true;

  String _passwordpassword_field = ''; // To store the first password

  void _validatePasswordpassword_field(String password) {
    setState(() {
      _isPasswordValidpassword_field = password.isNotEmpty;
      _passwordpassword_field = password; // Store the password for later comparison
      _doPasswordsMatchpassword_field = true; // Reset match flag on new input
    });
  }

  void _validateConfirmPasswordpassword_field(String confirmPassword) {
    setState(() {
      _doPasswordsMatchpassword_field = confirmPassword == _passwordpassword_field;
    });
  }








  @override
  void initState() {
    super.initState();
    final provider = Provider.of<Basicp1ViewModelScreen>(context, listen: false);
























}

 
  @override
  Widget build(BuildContext context) {
    final provider = Provider.of<Basicp1ViewModelScreen>(context, listen: false);
    return Scaffold(
      appBar: CustomAppBar(
          height: getVerticalSize(49),
          leadingWidth: 40,
          leading: AppbarImage(
              height: getSize(24),
              width: getSize(24),
              svgPath: ImageConstant.imgArrowleftBlueGray900,
              margin: getMargin(left: 16, top: 12, bottom: 13),
              onTap: () {
                Navigator.pop(context);
              }),
          centerTitle: true,
          title: AppbarTitle(text: "Update Basicp1"),        actions: [
























        ],
),
      body:  SingleChildScrollView(
        child: Padding(
          padding: const EdgeInsets.all(16),
          child: Form(
            key: _formKey,
            child: Column(
              children: [
 
                        ReusableTextField(
                           
                            label: "Please Enter name",
                            initialValue: widget.entity['name'] ?? '',

   // ValidationProperties
                            onSaved: (value) => widget.entity['name'] = value,
),
                    
                          SizedBox(height: 16),



                        ReusableTextField(
                           
                            label: "Please Enter name2",
                            initialValue: widget.entity['name2'] ?? '',

   // ValidationProperties
                            onSaved: (value) => widget.entity['name2'] = value,
),
                    
                          SizedBox(height: 16),


 ReusableTextField(
              initialValue: widget.entity['number1'].toString(),
              onSaved: (value) => widget.entity['number1']= value,
              label: "Enter number1",
              keyboardType: TextInputType.number,
              inputFormatters: [
                FilteringTextInputFormatter.allow((RegExp(r'[0-9]'))),
              ],
              validator: (value) {
                if (value == null || value.isEmpty) {
                  return 'Please enter a number';
                }
                return null;
              },
            ),

 ReusableTextField(
              initialValue: widget.entity['number2'].toString(),
              onSaved: (value) => widget.entity['number2']= value,
              label: "Enter number2",
              keyboardType: TextInputType.number,
              inputFormatters: [
                FilteringTextInputFormatter.allow((RegExp(r'[0-9]'))),
              ],
              validator: (value) {
                if (value == null || value.isEmpty) {
                  return 'Please enter a number';
                }
                return null;
              },
            ),

ReusableTextField(
              initialValue: widget.entity['phone_number'],
              onSaved: (value) => widget.entity['phone_number'] = value,
              label: "Enter Phone Number",
              keyboardType: TextInputType.number,
              inputFormatters: [
                FilteringTextInputFormatter.digitsOnly,
 LengthLimitingTextInputFormatter(
                        10), // Limit input to 10 digits
              ],
              validator: (value) {
                if (value == null || value.isEmpty) {
                  return 'Please enter  Phone Number';
                }
                if (value.length != 10) {
                      return 'Phone number must be exactly 10 digits';
                    }
                    return null;
              },
            ),

ReusableTextField(
              initialValue: widget.entity['phone_number2'],
              onSaved: (value) => widget.entity['phone_number2'] = value,
              label: "Enter Phone Number2",
              keyboardType: TextInputType.number,
              inputFormatters: [
                FilteringTextInputFormatter.digitsOnly,
 LengthLimitingTextInputFormatter(
                        10), // Limit input to 10 digits
              ],
              validator: (value) {
                if (value == null || value.isEmpty) {
                  return 'Please enter  Phone Number2';
                }
                if (value.length != 10) {
                      return 'Phone number must be exactly 10 digits';
                    }
                    return null;
              },
            ),

 // }),
            ReusableTextField(
              initialValue: widget.entity['paragraph_field'],
              onSaved: (value) =>  widget.entity['paragraph_field']= value,
              label: "Enter Paragraph Field",
              maxLines: 5,
            ),

 // }),
            ReusableTextField(
              initialValue: widget.entity['paragraph_field2'],
              onSaved: (value) =>  widget.entity['paragraph_field2']= value,
              label: "Enter Paragraph Field2",
              maxLines: 5,
            ),

TextFormField(
              initialValue: widget.entity['password_field'],

                  obscureText: !_passwordVisiblepassword_field,
                  decoration: InputDecoration(
                    labelText: 'Password Field',
                    suffixIcon: IconButton(
                      icon: Icon(
                        _passwordVisiblepassword_field
                            ? Icons.visibility
                            : Icons.visibility_off,
                      ),
                      onPressed: () {
                        setState(() {
                          _passwordVisiblepassword_field = !_passwordVisiblepassword_field;
                        });
                      },
                    ),
                    errorText:
                        _isPasswordValidpassword_field ? null : 'Please enter a password',
                    border: OutlineInputBorder(),
                  ),
                  onSaved: (value) => widget.entity['password_field'] = value,
                  onChanged: _validatePasswordpassword_field,
                ),
                const SizedBox(height: 16),
                TextFormField(
                  obscureText: !_passwordVisiblepassword_field,
                  decoration: InputDecoration(
                    labelText: 'Confirm Password Field',
                    suffixIcon: IconButton(
                      icon: Icon(
                        _passwordVisiblepassword_field
                            ? Icons.visibility
                            : Icons.visibility_off,
                      ),
                      onPressed: () {
                        setState(() {
                          _passwordVisiblepassword_field = !_passwordVisiblepassword_field;
                        });
                      },
                    ),
                    errorText:
                        _doPasswordsMatchpassword_field ? null : 'Passwords do not match',
                    border: OutlineInputBorder(),
                  ),
                  onChanged: _validateConfirmPasswordpassword_field,
                ),





            ReusableTextField(
              initialValue: widget.entity['textarea'],
              onSaved: (value) => widget.entity['textarea']= value,
              label: "Enter Textarea",
              maxLines: 5,
            ),


            ReusableTextField(
              initialValue: widget.entity['textarea_field'],
              onSaved: (value) => widget.entity['textarea_field']= value,
              label: "Enter Textarea Field",
              maxLines: 5,
            ),


            ReusableTextField(
              initialValue: widget.entity['textarea_field2'],
              onSaved: (value) => widget.entity['textarea_field2']= value,
              label: "Enter Textarea Field2",
              maxLines: 5,
            ),

 
          CustomButton(
                  height: getVerticalSize(50),
                  text: "Update",
                  margin: getMargin(top: 24, bottom: 5),
                  onTap: () async {
                    if (_formKey.currentState!.validate()) {
                      _formKey.currentState!.save();
























       
                        try {
                        await provider.updateEntity(
                              widget.entity[
                                  'id'], // Assuming 'id' is the key in your entity map
                              widget.entity);   

























                        Navigator.pop(context);
                      } catch (e) {
                        // ignore: use_build_context_synchronously
                        showDialog(
                          context: context,
                          builder: (BuildContext context) {
                            return AlertDialog(
                              title: const Text('Error'),
                              content:
                              Text('Failed to update Basicp1: $e'),
                              actions: [
                                TextButton(
                                  child: const Text('OK'),
                                  onPressed: () {
                                    Navigator.of(context).pop();
 },
                                  ),
                                ],
                              );
                            },
                          );
                        }
                      }
                    },
                  ),
                ],
              ),
            ),
          ),
       ),
       );
  }
}